<?php

    // From /etc/httpd/conf.d/kolab-freebusy.conf:
    //
    // RewriteEngine On
    // RewriteRule ^/freebusy/trigger/(.*) /usr/share/kolab-freebusy/index.php?trigger=$1 [L]
    // RewriteRule ^/freebusy/(.*)         /usr/share/kolab-freebusy/index.php?request=$1 [L]

    // $_GET["request"] contains the $email.$extension part of the request as
    // per the rewrite rules stated above.

    if (isset($_GET["request"])) {

        // Canonify whatever email address the Free/Busy information is
        // requested for to the cyrus-sasl/result_attribute in
        // /etc/kolab/kolab.conf.
        //
        // I.e., requesting /freebusy/john.doe@example.org.ifb is fine, as
        // john.doe@example.org is the 'mail' attribute value of John's LDAP
        // entry. John's LDAP entry however also has "j.doe@example.org" and
        // "doe@example.org".
        // 
        // The files "j.doe@example.org.ifb" and "doe@example.org.ifb" do not
        // exist, however.
        // 
        // When attempting to canonify, the user may not be a Kolab user at all.
        // Use the following settings from /etc/kolab/kolab.conf (in order):
        // 
        // [$domain]
        // - kolab_user_base_dn, kolab_user_filter and kolab_user_scope,
        // - user_base_dn, user_filter and user_scope,
        //
        // [ldap]
        // - kolab_user_base_dn, kolab_user_filter and kolab_user_scope,
        // - user_base_dn, user_filter and user_scope,

/*
        // Should return a boolean FALSE or a string of the primary recipient
        // address for the user.
        $kolab_user = kolab_user($_GET["request"]);

        if ($kolab_user == FALSE || empty($kolab_user) || !is_array($kolab_user)) {
            // Look for something external
        } else {
            $primary_mail = $kolab_user[$cyrus_sasl_result_attribute];
        }

*/

        if (is_file("/var/lib/kolab-freebusy/" . $_GET["request"])) {
            $response = file_get_contents("/var/lib/kolab-freebusy/" . $_GET["request"]);
            print "$response";
            return;
        } else {
            // Return an apparent empty Free/Busy list.

            $timestamp = gmdate("Ymd") . "T" . gmdate("His") . "Z";

            // Local timezone identifier
            //print date("e");

            // No difference in seconds since epoch for date() / gmdate()
            //print date("U") . "\n";
            //print gmdate("U") . "\n";

            $now = gmdate("U");

            // NOTE: The following settings should probably correspond with
            // whatever period of time kolab-freebusyd thinks it should use.

            // Should probably be a setting. For now, do 8 weeks in the past
            $start = $now - (60 * 60 * 24 * 7 * 8);

            // Should probably be a setting. For now, do 16 weeks into the future
            $end = $now + (60 * 60 * 24 * 7 * 16);

            $dtstart = gmdate("Ymd", $start) . "T" . gmdate("His", $start) . "Z";
            $dtend = gmdate("Ymd", $end) . "T" . gmdate("His", $end) . "Z";

            print "BEGIN:VCALENDAR\n";
            print "VERSION:2.0\n";
            print "PRODID:-//kolab.org//NONSGML Kolab Server 2//EN\n";
            print "METHOD:PUBLISH\n";
            print "BEGIN:VFREEBUSY\n";
            print "ORGANIZER:MAILTO:" . basename($_GET["request"], ".ifb") . "\n";
            print "DTSTAMP:" . $timestamp . "\n";
            print "URL:http://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"] . "\n";
            print "DTSTART:" . $dtstart . "\n";
            print "DTEND:" . $dtend . "\n";
            print "COMMENT:This is a dummy vfreebusy that indicates an empty calendar\n";
            print "FREEBUSY:19700101T000000Z/19700101T000000Z\n";
            print "END:VFREEBUSY\n";
            print "END:VCALENDAR\n";
        }
    }

?>

